using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Xml;
using System.Text;
using System.IO;


namespace GEN
{
	/// <summary>
	/// Summary description for GENUI_SPECIFICATION.
	/// </summary>
	public class GENUI_NT: System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox textBox_T;
		private System.Windows.Forms.Button btnNTPerT;
		private System.Windows.Forms.PictureBox pictureBox_Graph;
		private System.Windows.Forms.Button ShowBtn;
		private System.Windows.Forms.Label label1;

		//variables
		private Hashtable hashSequence;
		private Hashtable neighbors_hash;
		private Hashtable id_ip_hash;
		private XmlDocument xmlDoc;
		private int T;
		private bool _isOnACM;
		private ArrayList visited;
		private int _PowerRange;
		private int _SA_Width;
		private int _SA_Height;
		private System.Windows.Forms.MainMenu mainMenu1;


		//Color list
		Color[] colorList = {Color.Blue, Color.Red, Color.Green, Color.Purple, Color.Gold,
								Color.DarkGoldenrod, Color.Orange, Color.Black, Color.Pink, Color.DarkBlue,
								Color.AliceBlue, Color.Brown, Color.Gainsboro, Color.Honeydew, Color.Khaki,
								Color.Lavender, Color.OldLace, Color.ForestGreen, Color.SaddleBrown, Color.PaleTurquoise};

	
		public GENUI_NT()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			xmlDoc = new XmlDocument();
			neighbors_hash = new Hashtable();
			id_ip_hash = new Hashtable();
			visited = new ArrayList();
			_PowerRange = GEN_CONSTANTS.POWER_RANGE;
			_SA_Width = GEN_CONSTANTS.DEFAULT_SA_WIDTH;
			_SA_Height = GEN_CONSTANTS.DEFAULT_SA_HEIGHT;

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		public GENUI_NT(bool p_isOnACM, Hashtable p_id_ip_hash, int p_PowerRange,
			            int p_SA_Width, int p_SA_Height)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			xmlDoc = new XmlDocument();
			_isOnACM = p_isOnACM;
			neighbors_hash = new Hashtable();
			id_ip_hash = p_id_ip_hash;
			visited = new ArrayList();
			_PowerRange = p_PowerRange;
			_SA_Width = p_SA_Width;
			_SA_Height = p_SA_Height;
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.panel2 = new System.Windows.Forms.Panel();
			this.ShowBtn = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.textBox_T = new System.Windows.Forms.TextBox();
			this.btnNTPerT = new System.Windows.Forms.Button();
			this.pictureBox_Graph = new System.Windows.Forms.PictureBox();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			// 
			// panel2
			// 
			this.panel2.BackColor = System.Drawing.Color.Khaki;
			this.panel2.Controls.Add(this.ShowBtn);
			this.panel2.Controls.Add(this.label1);
			this.panel2.Controls.Add(this.label3);
			this.panel2.Controls.Add(this.textBox_T);
			this.panel2.Controls.Add(this.btnNTPerT);
			this.panel2.Controls.Add(this.pictureBox_Graph);
			this.panel2.Location = new System.Drawing.Point(0, -29);
			this.panel2.Size = new System.Drawing.Size(240, 384);
			// 
			// ShowBtn
			// 
			this.ShowBtn.Location = new System.Drawing.Point(16, 272);
			this.ShowBtn.Size = new System.Drawing.Size(96, 32);
			this.ShowBtn.Text = "Show NT";
			this.ShowBtn.Click += new System.EventHandler(this.ShowBtn_Click);
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Bold);
			this.label1.Location = new System.Drawing.Point(8, 32);
			this.label1.Size = new System.Drawing.Size(224, 24);
			this.label1.Text = "Network  Topology";
			this.label1.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 0);
			this.label3.Size = new System.Drawing.Size(224, 24);
			this.label3.Text = "Network  Topology";
			this.label3.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// textBox_T
			// 
			this.textBox_T.Location = new System.Drawing.Point(192, 280);
			this.textBox_T.Size = new System.Drawing.Size(40, 22);
			this.textBox_T.Text = "";
			// 
			// btnNTPerT
			// 
			this.btnNTPerT.Location = new System.Drawing.Point(120, 272);
			this.btnNTPerT.Size = new System.Drawing.Size(56, 32);
			this.btnNTPerT.Text = "T";
			this.btnNTPerT.Click += new System.EventHandler(this.btnNTPerT_Click);
			// 
			// pictureBox_Graph
			// 
			this.pictureBox_Graph.Location = new System.Drawing.Point(8, 64);
			this.pictureBox_Graph.Size = new System.Drawing.Size(224, 200);
			// 
			// GENUI_NT
			// 
			this.ClientSize = new System.Drawing.Size(240, 327);
			this.Controls.Add(this.panel2);
			this.Menu = this.mainMenu1;
			this.Text = "GENUI_NT";
			this.Load += new System.EventHandler(this.GENUI_NT_Load);

		}
		#endregion


		private void btnNTPerT_Click(object sender, System.EventArgs e)
		{
			Bitmap bmp = new Bitmap(pictureBox_Graph.Width, pictureBox_Graph.Height);
			Graphics graphic = Graphics.FromImage(bmp);
			showNTWithT(ref graphic); 			
			pictureBox_Graph.Image = bmp;

		}
		private void showNTWithT(ref Graphics g)
		{
			SolidBrush bgrdBrush = new SolidBrush(Color.Beige);
			g.FillRectangle(bgrdBrush,0,0,
				pictureBox_Graph.Width, pictureBox_Graph.Height);		

			Hashtable node_location_list = new Hashtable();
			try
			{
				//T++;
				//textBox_T.Text = T.ToString();
				T = int.Parse(textBox_T.Text);
				//Check the location of each node
                //MessageBox.Show("T is "+T);
				IDictionaryEnumerator ide =hashSequence.GetEnumerator();
				while(ide.MoveNext())
				{
					string node_id = ide.Key.ToString();
					Point point = new Point();
					point = getLocation(T, node_id);
					node_location_list.Add(node_id, point);
				}

				//showNodeList(node_location_list);

				writeNodePoints(ref g, node_location_list);
				drawTopology(node_location_list,ref g);//if two nodes are connected, the line is drawn. 
				//Otherwise, no line is drawn between two nodes.
			  
			}
			catch(Exception e)
			{
				MessageBox.Show("Your input T is not valid! ");
			}


		}//showNTWithT

		private void adjustTwoPositions(ref double p_row, ref double p_col)
		{
			try
			{
				if((_SA_Width > GEN_CONSTANTS.DEFAULT_SA_WIDTH) ||
					(_SA_Height > GEN_CONSTANTS.DEFAULT_SA_HEIGHT))
				{
					double y_alpha = (double.Parse(GEN_CONSTANTS.DEFAULT_SA_WIDTH.ToString())/double.Parse(_SA_Width.ToString()));
					double x_beta =  (double.Parse(GEN_CONSTANTS.DEFAULT_SA_HEIGHT.ToString())/double.Parse(_SA_Height.ToString()));
					p_row = double.Parse(p_row.ToString())*x_beta;
					p_col = double.Parse(p_col.ToString())*y_alpha;
				}
			}
			catch(Exception e)
			{
				MessageBox.Show("Exception in adjustPositions() : "+e.Message);
			}
		}

		private void writeNodePoints(ref Graphics g, Hashtable id_location)
		{
			try
			{
				IDictionaryEnumerator ide = id_location.GetEnumerator();
				Font idFont = new Font(FontFamily.GenericSansSerif, 8, FontStyle.Regular);
				int i = 0;
				while(ide.MoveNext())
				{
					Point p = (Point)ide.Value;
					adjustTwoPositions(ref p.row, ref p.col);
					float x = Convert.ToSingle(Convert.ToInt32(p.row));
					float y = Convert.ToSingle(Convert.ToInt32(p.col));

					SolidBrush color = new SolidBrush(colorList[i]);
					g.DrawString(ide.Key.ToString(),idFont,color,x,y);//mark the location of each node
					i++;
				}
			}
			catch(Exception e)
			{
               MessageBox.Show("Exception in writeNodePoints(): "+e.Message);
			}
		}

		private Point getLocation(int T, string p_source)
		{
			try
			{
				ArrayList sequence = new ArrayList();
				IDictionaryEnumerator ide = hashSequence.GetEnumerator();
				while(ide.MoveNext())
				{
					if(ide.Key.ToString().Equals(p_source))
					{
						sequence = (ArrayList)ide.Value;
					}
				}
				Sequence[] rl = new Sequence[10];  
				sequence.CopyTo(0,rl,0,sequence.Count);
				double elapsed_time = 0;			
				int i =0;
				Point startPoint = getStartPoint(p_source);
				double distance = 0;
				int speed = 0;
				int pause = 0;
				double previous_elapsed_time =0;

				double x1 = 0;
				double y1 = 0;
				double x2 = 0;
				double y2 = 0;
			
				while(elapsed_time<T)
				{
					if(i>=rl.Length)
					{
						i=0;
					}//when 10 destinations are traversed already, 
					//it circles by being back to the beginning.-->Reset

					if(i==0)
					{
						x1 = startPoint.row;
						y1 = startPoint.col;
					}
					else
					{
						x1 = rl[i-1].destination.row;
						y1 = rl[i-1].destination.col;
					}
					x2 = rl[i].destination.row;
					y2 = rl[i].destination.col;
					Point point1 = new Point (x1, y1);
					Point point2 = new Point (x2, y2);
					distance = getDistance(point1, point2);

					speed = rl[i].speed;
					pause = rl[i].pause;
					previous_elapsed_time = elapsed_time;
					//MessageBox.Show("D/S: "+(distance/double.Parse(speed.ToString())));
					//MessageBox.Show("i = "+i);
					elapsed_time = elapsed_time +(distance/double.Parse(speed.ToString()));
					double remainedT =0;
					if(elapsed_time>T)//location is on the way to the destination
					{
						remainedT =T-previous_elapsed_time;
						double distanceFarFromPrevPoint = remainedT*speed; 
            
						Point p = getPointOnTheWay(point1, point2,distanceFarFromPrevPoint);
						//MessageBox.Show("On the Way : "+p.row+","+p.col);
						return p;
					}
					else
					{
						elapsed_time = elapsed_time + double.Parse(pause.ToString());
						if(elapsed_time>=T)//point location stays at the destination point
						{
							Point p = new Point(rl[i].destination.row,rl[i].destination.col); 
							//MessageBox.Show("On the Destination : "+p.row+","+p.col);
							return p;                      
						}
					}
					i++;
				}//while
				if(T==0)
				{
					x1 = startPoint.row;
					y1 = startPoint.col;
					Point p = new Point(x1,y1);
					return p;
				}
				// MessageBox.Show("No Point (0,0)");
			}
			catch(Exception e)
			{
                MessageBox.Show("Exception in getLocation(): "+e.Message);
			}
			return new Point(0,0);
		}//end of method

		/// <summary>
		/// In Hashtable hashSequence, source as Key and sequence as Value are stored.
		/// </summary>
		public void storeSequenceInHashtable()
		{
			try
			{
				XmlNode root = xmlDoc.DocumentElement;//configuration root element
				XmlNodeList xNodes = root.ChildNodes;
											
				foreach(XmlNode childNode in xNodes)//<Node>
				{
					XmlElement currentElement = (XmlElement)childNode;
					//add to the hashSequence
					string source = currentElement.GetAttribute("ID").ToString();
					XmlNodeList SequenceNodes = childNode.ChildNodes;
					ArrayList temp_sequence = new ArrayList();
					foreach(XmlNode sequenceNode in SequenceNodes)//<Sequence>
					{
						XmlNodeList hopNodes = sequenceNode.ChildNodes; 

						foreach(XmlNode hopNode in hopNodes)//<Hop>
						{
							XmlNodeList pathNodes = hopNode.ChildNodes;
							Sequence s = new Sequence();
							foreach(XmlNode pathNode in pathNodes)
							{

								XmlElement cn = (XmlElement)pathNode;
								if(cn.Name.Equals("Destination"))
								{
									string temp = cn.FirstChild.Value;

									Point p = new Point();
									p.row = getRow(temp);
									p.col = getCol(temp);
									s.destination = p;
								}
								else if(cn.Name.Equals("Speed"))
								{
									s.speed = Convert.ToInt32(cn.FirstChild.Value);
								}
								else//Pause
								{
									s.pause = Convert.ToInt32(cn.FirstChild.Value);
								}
							}
							temp_sequence.Add(s);
						}
					}//outer foreach
					hashSequence.Add(source,temp_sequence);
				}									               
			}
			catch(Exception ex)
			{
				MessageBox.Show("Exception in storeSequenceInHashtable():"+ex.Message);
			}   
		}

		private void ShowBtn_Click(object sender, System.EventArgs e)
		{
			//showHashSequence();                
			drawGraph();

		}//end of storeSequenceInHashtable()
		public void drawGraph()
		{
			Bitmap bmp = new Bitmap(pictureBox_Graph.Width, pictureBox_Graph.Height);
			   
			Graphics graphic = Graphics.FromImage(bmp);
			SolidBrush bgrdBrush = new SolidBrush(Color.White);
			graphic.FillRectangle(bgrdBrush,0,0,
				pictureBox_Graph.Width, pictureBox_Graph.Height);		
			//Show Node list			   
			//Paint the Graph and NodeColor
			IDictionaryEnumerator ide =id_ip_hash.GetEnumerator();
			ArrayList colorBrush = getColorList(id_ip_hash.Count);
			int i = 0;
			Font idFont = new Font(FontFamily.GenericSansSerif, 8, FontStyle.Regular);
			while(ide.MoveNext())
			{
				//MessageBox.Show("i ="+i);
				Point startPoint =getStartPoint(ide.Key.ToString());
				try
				{
					float xStart = Convert.ToSingle(startPoint.row);
					float yStart = Convert.ToSingle(startPoint.col);
					//MessageBox.Show("when i = "+i+"x = "+xStart+" y = "+yStart);
					SolidBrush color = new SolidBrush((Color)colorBrush[i]);
					graphic.DrawString(ide.Key.ToString(),idFont,color,xStart, yStart);
					drawTrajectory(graphic, ide.Key.ToString(), i);               					                  
					i++;
				}
				catch(Exception e)
				{
					MessageBox.Show("Exception occurred when startPoint is cast to float " +e.Message);
				}
			}			   				
			pictureBox_Graph.Image = bmp;
		}

		private void showHashSequence()
		{
			try
			{
				string inside ="HashSequence: \r\n";
				IDictionaryEnumerator ide = hashSequence.GetEnumerator();   
				while(ide.MoveNext())
				{
					string strSeq = "";
					inside = inside +ide.Key.ToString()+" :\r\n";
					ArrayList temp_al = (ArrayList)ide.Value;
					for(int i = 0; i<temp_al.Count; i++)
					{
						Sequence s = (Sequence)temp_al[i];						
						strSeq =strSeq+"D = ("+s.destination.row+","+s.destination.col+") S= "+
							s.speed+" P= "+s.pause+"\r\n";							
					}
					inside = inside+strSeq;
				}
				MessageBox.Show(inside);
			}
			catch(Exception e)
			{
                MessageBox.Show("Exception in showHashSequence() :"+e.Message);
			}
		}
		private ArrayList getSequenceList(string p_node_id)
		{
			ArrayList temp_al = new ArrayList();
			try
			{
				IDictionaryEnumerator ide = hashSequence.GetEnumerator();
				while(ide.MoveNext())
				{
					if(ide.Key.ToString().Equals(p_node_id))
					{
						temp_al = (ArrayList)ide.Value;
						break;
					}
				}
			}
			catch(Exception e)
			{
				MessageBox.Show("Exception in getSequenceList(): "+e.Message);
			}
			return temp_al;
		}

		private void drawTrajectory(Graphics p_graphic, string p_node_id, int index)
		{
			Point startPoint = getStartPoint(p_node_id);
			int startRow = Convert.ToInt32(startPoint.row);
			int startCol = Convert.ToInt32(startPoint.col);
			
			//Sequence[] rl = (Sequence[])all_sequences[index];
			ArrayList temp_sequence_list = getSequenceList(p_node_id);
			Pen pen = new Pen(colorList[index]);
			int length = temp_sequence_list.Count;
			//showSequenceList(p_node_id);
			for(int i=0; (i<length && (i+1)<length); i++)
			{
				Sequence seq1 = new Sequence();
				seq1 = (Sequence)temp_sequence_list[i];
				Sequence seq2 = new Sequence();
				seq2 = (Sequence)temp_sequence_list[i+1];
				Point point1 = new Point(seq1.destination.row, seq1.destination.col);
				Point point2 = new Point(seq2.destination.row, seq2.destination.col);	
				int xStart = Convert.ToInt32(point1.row);
				int yStart = Convert.ToInt32(point1.col);
				int xEnd = Convert.ToInt32(point2.row);
				int yEnd = Convert.ToInt32(point2.col);
				//MessageBox.Show("Before adjustPositions(): ("+xStart+","+yStart+") ("+xEnd+" , "+yEnd+")");
				adjustPositions(ref xStart, ref yStart, ref xEnd, ref yEnd);
				//MessageBox.Show("After adjustPositions(): ("+xStart+","+yStart+") ("+xEnd+" , "+yEnd+")");
				p_graphic.DrawLine(pen, xStart, yStart, xEnd, yEnd);
				if(i==0)//draw a line from the original point to the first destination.
				{
					adjustPositions(ref startRow, ref startCol, ref xStart, ref yStart);
					//MessageBox.Show("After adjustPositions() in i==0 : ("+startRow+","+startCol+") ("+xStart+" , "+yStart+")");
					p_graphic.DrawLine(pen, startRow, startCol, xStart, yStart);
				}
			}
		}

		private void adjustPositions(ref int p_xStart, ref int p_yStart, 
			                         ref int p_xEnd, ref int p_yEnd)
		{
			try
			{
				if((_SA_Width > GEN_CONSTANTS.DEFAULT_SA_WIDTH) ||
					(_SA_Height > GEN_CONSTANTS.DEFAULT_SA_HEIGHT))
				{
					double y_alpha = (double.Parse(GEN_CONSTANTS.DEFAULT_SA_WIDTH.ToString())/double.Parse(_SA_Width.ToString()));
					double x_beta =  (double.Parse(GEN_CONSTANTS.DEFAULT_SA_HEIGHT.ToString())/double.Parse(_SA_Height.ToString()));
					//MessageBox.Show("_SA_Width: "+_SA_Width+" _SA_Height: "+ _SA_Height);
					//MessageBox.Show("alpha: "+y_alpha+"  beta: "+x_beta);
					double temp_xStart = double.Parse(p_xStart.ToString())*x_beta;
					double temp_yStart = double.Parse(p_yStart.ToString())*y_alpha;
					double temp_xEnd = double.Parse(p_xEnd.ToString())*x_beta;
					double temp_yEnd = double.Parse(p_yEnd.ToString())*y_alpha;
					//MessageBox.Show("temp_xStart: "+temp_xStart+" temp_yStart: "+temp_yStart);
					//MessageBox.Show("temp_xEnd: "+temp_xEnd+" temp_yEnd: "+temp_yEnd);
					p_xStart = Convert.ToInt32(temp_xStart);
					p_yStart = Convert.ToInt32(temp_yStart);
					p_xEnd = Convert.ToInt32(temp_xEnd);
					p_yEnd = Convert.ToInt32(temp_yEnd);
					//MessageBox.Show("p_xStart: "+p_xStart+" p_yStart: "+p_yStart);
					//MessageBox.Show("p_xEnd: "+p_xEnd+" p_yEnd: "+p_yEnd);
				}
			}
			catch(Exception e)
			{
               MessageBox.Show("Exception in adjustPositions() : "+e.Message);
			}
		}
 
       
		private void showSequenceList(string p_node_id)
		{
			try
			{
				ArrayList temp = new ArrayList();
				temp = getSequenceList(p_node_id);
				string inside = p_node_id+": \r\n";
				for(int i = 0; i<temp.Count; i++)
				{
					Sequence seq = (Sequence)temp[i];
					inside = inside + "D = ("+seq.destination.row+","+seq.destination.col+") S= "+
						seq.speed+" P= "+seq.pause+"\r\n";
				}
				MessageBox.Show("SequenceList for "+inside);
			}
			catch(Exception e)
			{
				MessageBox.Show("Exception in showSequenceList(): "+e.Message);
			}             
		}

		private Point getStartPoint(string p_source_id)
		{
			try
			{
				XmlNode root = xmlDoc.DocumentElement;//configuration root element
				XmlNodeList xNodes = root.ChildNodes;
											
				foreach(XmlNode childNode in xNodes)
				{
					
					XmlElement currentElement = (XmlElement)childNode;

					if(currentElement.GetAttribute("ID").Equals(p_source_id))
					{
						string stPt = currentElement.GetAttribute("StartPt");
						double row = getRow(stPt);
						double col = getCol(stPt);
						Point startPoint = new Point(row, col);
						return startPoint;
					}
				}		
			}
			catch(Exception e)
			{
				MessageBox.Show("Exception occurred in getStartPoint() : "+e.Message);
			}
			return new Point(-1,-1);           
		}

		/// <summary>
		/// When string (row,col) is passed as a parameter, return row as an integer
		/// </summary>
		/// <param name="s">destination</param>
		/// <returns>row as an integer</returns>
		public int getRow(string s)
		{
			try
			{
				int leftP = s.IndexOf("(");		
				int dot = s.IndexOf(",");
				string strRow = s.Substring(leftP+1, dot-1);
				//MessageBox.Show("strRow : "+strRow);
				int row = Convert.ToInt32(strRow);
				return row;
			}
			catch(Exception e)
			{
				MessageBox.Show("getRow() Exception occurred :"+e.Message);                
				return -1;
			}
		}

		/// <summary>
		/// When string (row,col) is passed as a parameter, return col as an integer
		/// </summary>
		/// <param name="s">destination</param>
		/// <returns>col as an integer</returns>
		public int getCol(string s)
		{
			try
			{
				int rightP = s.IndexOf(")");
				int dot = s.IndexOf(",");
				int left = dot+1;
				int right =rightP-left;
				//MessageBox.Show("left : "+left+" right :"+right);
				string strCol = s.Substring(dot+1, right);
				//MessageBox.Show("strCol : "+strCol);
				int col = Convert.ToInt32(strCol);
				return col;
			}
			catch(Exception e)
			{
				MessageBox.Show("getCol() Exception occurred :"+e.Message);                
				return -1;
			}
		}

		private void showInsideNeighbors_hash()
		{
			string inside ="";
			IDictionaryEnumerator ide = neighbors_hash.GetEnumerator();
			while(ide.MoveNext())
			{
				inside = inside+ide.Key.ToString()+": ";
				ArrayList al = new ArrayList();
				al = (ArrayList)ide.Value;
				IEnumerator ie = al.GetEnumerator();
				while(ie.MoveNext())
				{
					inside = inside+ie.Current.ToString()+" ";
				}
				inside = inside+"\r\n";
			}
			MessageBox.Show("Inside Neighbors_hash: "+"\r\n"+inside);
		}

		public void showNodeList(Hashtable p_node_list)
		{
			try
			{
				IDictionaryEnumerator ide = p_node_list.GetEnumerator();
				string inside = "";
				while(ide.MoveNext())
				{ 
					Point point = (Point)ide.Value;
					inside = inside+ide.Key.ToString()+": ("+point.row.ToString()+" , "+
						point.col.ToString()+")";
					inside = inside+"\r\n";               
				}
				MessageBox.Show("Node List : "+inside);
			}
			catch(Exception e)
			{
				MessageBox.Show("Exception in showNodeList(): "+e.Message);
			}
		}


		private void drawTopology(Hashtable p_node_list, ref Graphics g)
		{
			try
			{
				//debugging
				//showNodeList(p_node_list);				
				///////////////////////////
				adjustNetworkTopology(p_node_list);
				//MessageBox.Show("After ajusting network topology");
				//showInsideNeighbors_hash();
				ArrayList visitedNodes = new ArrayList();
				IDictionaryEnumerator ide = neighbors_hash.GetEnumerator();
				while(ide.MoveNext())
				{
					Point point1 = getPointFromNodeList(ide.Key.ToString(), p_node_list);
					visitedNodes.Add(ide.Key.ToString());
					ArrayList al = (ArrayList)ide.Value;
					IEnumerator ie = al.GetEnumerator();
					while(ie.MoveNext())
					{
						Point point2 = getPointFromNodeList(ie.Current.ToString(), p_node_list);
						if(!visitedNodes.Contains(ie.Current.ToString()))
						{
							connect(ref g, point1, point2);
						}
					}//end of inner while                
				}//end of outer while			 
			}
			catch(Exception e)
			{
				MessageBox.Show("Exception in drawTopology(): "+e.Message);
			}
		}
		/// <summary>
		/// To gurantee the network topology is always connected with each nodes with multiple hops.
		/// </summary>
		/// <param name="p_node_list"></param>
		private void adjustNetworkTopology(Hashtable p_node_list)
		{
			try
			{
				neighbors_hash.Clear();
				IDictionaryEnumerator outer_ide = p_node_list.GetEnumerator();
				IDictionaryEnumerator inner_ide = p_node_list.GetEnumerator();
				while(outer_ide.MoveNext())
				{
					Point point1 = (Point)outer_ide.Value;
					ArrayList neighbors_al = new ArrayList();
					while(inner_ide.MoveNext())
					{
						if(!outer_ide.Key.ToString().Equals(inner_ide.Key.ToString()))
						{
							Point point2 = (Point)inner_ide.Value;				
							if(isConnected(point1, point2))
							{
								neighbors_al.Add(inner_ide.Key.ToString());
							}
						}
					}//inner while
					neighbors_hash.Add(outer_ide.Key.ToString(), neighbors_al);
					inner_ide.Reset();//reset the inner ie
				}//outer while
				//MessageBox.show("After collecting network neighbors : no modification");
				//showInsideNeighbors_hash();
				if(_isOnACM)
				{
					modifyConnections(p_node_list);
				}
			}
			catch(Exception e)
			{
				MessageBox.Show("Exception in adjustNetworkTopology(): "+e.Message);
			}
		}

		private void modifyConnections(Hashtable p_node_list)
		{
			try
			{
				Hashtable checkList = p_node_list;
				bool isAllConnectedWithMultiHops = false;
				//MessageBox.Show("before checkMaxNeighbors()");
				//showInsideNeighbors_hash();
				checkMaxNeighbors(p_node_list);
				//MessageBox.Show("after checkMaxNeighbors()");
				//showInsideNeighbors_hash();
				int i = 0;
				int j = 0;
				string root = "";
				while(!isAllConnectedWithMultiHops)
				{
					ICollection ic = p_node_list.Keys;
					IEnumerator ie = ic.GetEnumerator();
					while(ie.MoveNext())
					{
						j++;
						if(j==1)
						{
							root = ie.Current.ToString(); 
						}
						string node = ie.Current.ToString();
						if(!isInSourceTree(root, node))
						{
							getConnected(node, p_node_list);
							visited.Clear();
							ie.Reset();
							j = 0;
							i=0;
							break;
						}
						else
						{
							i++;
							if(i==ic.Count)
							{
								isAllConnectedWithMultiHops = true;
								break;
							}
						}
					}               
				}
					
			}
			catch(Exception e)
			{
				MessageBox.Show("Exception in modifyConnections(): "+e.Message);
			}
		}
		
		private void getConnected(string p_node, Hashtable p_node_list)
		{
			try
			{
				IEnumerator ie = visited.GetEnumerator();
				string ProperNode = "";
				int minNeighbors = neighbors_hash.Count;
				while(ie.MoveNext())
				{
					string visitedNode =  ie.Current.ToString();
					//	MessageBox.Show("traversing visitedNode : "+visitedNode);
					ArrayList neighbors = getNeighbors(visitedNode);
					int neighborsNum = neighbors.Count;
					if(minNeighbors>neighborsNum)
					{
						minNeighbors = neighborsNum;
						ProperNode = visitedNode;
					}
				}//end of while
				//MessageBox.Show("selected ProperNode : "+ProperNode);
				makeNeighbors(ProperNode, p_node, p_node_list);
			}
			catch(Exception e)
			{
				MessageBox.Show("Exception in getConnected():"+e.Message);
			}
		}

		private void makeNeighbors(string properNode, string p_node, Hashtable p_node_list)
		{
			try
			{
				IDictionaryEnumerator ide = p_node_list.GetEnumerator();
				int i = 0;
				while(ide.MoveNext())
				{
					if(ide.Key.ToString().Equals(properNode))
					{
						ArrayList al = getNeighbors(ide.Key.ToString());
						al.Add(p_node);
						neighbors_hash.Remove(ide.Key.ToString());
						neighbors_hash.Add(ide.Key.ToString(), al);
						i++;
					}
					else if(ide.Key.ToString().Equals(p_node))
					{
						ArrayList al = getNeighbors(ide.Key.ToString());
						al.Add(properNode);
						neighbors_hash.Remove(ide.Key.ToString());
						neighbors_hash.Add(ide.Key.ToString(), al);
						i++;
					}
					else if(i==2)
					{
						break;
					}
				}
			}
			catch(Exception e)
			{
				MessageBox.Show("Exception in makeNeighbors() : "+e.Message);
			}
		}

		private bool isInSourceTree(string root, string node)
		{
			try
			{
				//MessageBox.Show("Before isInSourceTree()");
				//showInsideNeighbors_hash();
				//showInsideVisited();
				bool isConnected = false;
				Queue Q = new Queue();
				Q.Enqueue(root);
				visited.Add(root);
				while(!(Q.Count==0))
				{
					string temp_node = Q.Dequeue().ToString();
					if(temp_node.Equals(node))
					{
						isConnected = true;
						visited.Clear();
						return isConnected;
					}
					else
					{
						ArrayList neighbors = getNeighbors(temp_node); 
						for(int i=0; i<neighbors.Count; i++)
						{							
							string nb = neighbors[i].ToString();
							if(!isVisited(nb))
							{
								//showInsideVisited();
								//MessageBox.Show("not visited node: "+nb);
								Q.Enqueue(nb);
								visited.Add(nb);
							}
						}
					}                   
				}//end of while
				return isConnected;
			}
			catch(Exception e)
			{
				MessageBox.Show("Exception in isInSourcTree() : "+e.Message);
				return false;
			}
		}

		private bool isVisited(string node)
		{
			if(visited.Contains(node))
			{
				return true;
			}
			else
			{
				return false;
			}
		}


		
		private ArrayList getNeighbors(string p_node)
		{
			IDictionaryEnumerator ide = neighbors_hash.GetEnumerator();
			ArrayList al = new ArrayList();
			while(ide.MoveNext())
			{
				if(ide.Key.ToString().Equals(p_node))
				{
					al = (ArrayList)ide.Value;
					break;
				}
			}
			return al;
		}
		/// <summary>
		/// check if the network topology is all connected with multiple hops
		/// </summary>
		/// <param name="p_disconnectedNode"></param>
		/// <returns></returns>
	

		/// <summary>
		/// Check if each node is directly connected with more than half of participating nodes. 
		/// If so, cut off the neighboring nodes which are located farther from the node.
		/// </summary>
		/// <param name="p_max_neighbors"></param>
		private void checkMaxNeighbors(Hashtable p_node_list)
		{
			try
			{
				int max_neighbors = neighbors_hash.Count/2;
				IDictionaryEnumerator ide = p_node_list.GetEnumerator();
				//MessageBox.Show("num of nodes : "+neighbors_hash.Count);
				while(ide.MoveNext())
				{
					ArrayList al = getNeighbors(ide.Key.ToString());
					int numOfNeighbors = al.Count;
					//	MessageBox.Show(ide.Key.ToString());
					//	MessageBox.Show("numOfNeighbors : "+numOfNeighbors);
					//	MessageBox.Show("max_neighbors : "+max_neighbors);

					while(numOfNeighbors>max_neighbors)
					{
						cutOffProperNode(ide.Key.ToString(), al, p_node_list);
						numOfNeighbors--;
					}
					//	MessageBox.Show("after cutting off numOfNeighbors : "+numOfNeighbors);

				}   
				//MessageBox.Show("checkMax 8");
			}
			catch(Exception e)
			{
				MessageBox.Show("Exception in checkMaxNeighbors(): "+e.Message);
			}
		}

		private void cutOffProperNode(string p_node, ArrayList p_neighbors, Hashtable p_node_list)
		{
			try
			{
				Point node_point = getPointFromNodeList(p_node, p_node_list);
				string ProperNode = "NA";
				int maxNeighbors = 0;
				for(int i=0; i<p_neighbors.Count; i++)
				{
					string nb = p_neighbors[i].ToString();
					int numOfNeighbors = getNeighbors(nb).Count;
					if(maxNeighbors<numOfNeighbors)
					{
						maxNeighbors = numOfNeighbors;
						ProperNode = nb;
					}
				}
				removeProperNode(p_node, ProperNode, p_node_list);   
			}
			catch(Exception e)
			{
				MessageBox.Show("Exception in cutOffFarthestNode(): "+e.Message);
			}
		}

		private void removeProperNode(string p_node, string p_properNode, Hashtable p_node_list)
		{
			try
			{
				IDictionaryEnumerator ide = p_node_list.GetEnumerator();
				ArrayList al = new ArrayList();
				int i  = 0;
				while(ide.MoveNext())
				{
					if(ide.Key.ToString().Equals(p_node))
					{
						al = getNeighbors(p_node);
						al.Remove(p_properNode);
						neighbors_hash.Remove(p_node);
						neighbors_hash.Add(p_node, al);
						i++;
					}
					else if(ide.Key.ToString().Equals(p_properNode))
					{
						al = getNeighbors(p_properNode);
						al.Remove(p_node);
						neighbors_hash.Remove(p_properNode);
						neighbors_hash.Add(p_properNode, al);
						i++;
					}
					else if(i==2)
					{
						break;
					}
				}
			}
			catch(Exception e)
			{
				MessageBox.Show("Exception in removeFarthestNode(): "+e.Message);
			}

		}

		private ArrayList getColorList(int num_of_nodes)
		{
			ArrayList ColorList = new ArrayList();
			for(int i=0; i<num_of_nodes; i++)
			{
				ColorList.Add(colorList[i]);
			}
			return ColorList;
		}

		private double getDistance(Point p1, Point p2)
		{
			double powDistance = Math.Pow((p1.row-p2.row),2)+
				Math.Pow((p1.col-p2.col),2);
			double distance = Math.Sqrt(powDistance); 

			return Convert.ToDouble(Math.Round(Convert.ToDecimal(distance),2));
		}
		private Point getPointOnTheWay(Point point1, Point point2, double p_distanceFarFromPoint1)
		{
			try
			{
				double x1 = Convert.ToDouble(Math.Round(Convert.ToDecimal(point1.row),2));
				double y1 = Convert.ToDouble(Math.Round(Convert.ToDecimal(point1.col),2));
				double x2 = Convert.ToDouble(Math.Round(Convert.ToDecimal(point2.row),2));
				double y2 = Convert.ToDouble(Math.Round(Convert.ToDecimal(point2.col),2));
				double distance = getDistance(point1, point2);
				double approximateDistance = Convert.ToDouble(Math.Round(Convert.ToDecimal(p_distanceFarFromPoint1),2));
				if(distance>p_distanceFarFromPoint1)				
				{
					double toCalculateY = Convert.ToDouble(Math.Round(Convert.ToDecimal(approximateDistance*(Math.Abs((y1-y2))/distance)),2));
					double toCalculateX = Convert.ToDouble(Math.Round(Convert.ToDecimal(approximateDistance*(Math.Abs((x1-x2))/distance)),2));
					if((x1-x2)*(y1-y2)==0)//when slope == zero
					{
						//MessageBox.Show("("+x1+","+y1+")  ("+x2+","+y2+")");
						//MessageBox.Show("when slope is zero");
						if((x1-x2)==0)
						{

							if(y1<y2)
							{
								double y = Convert.ToDouble(Math.Round(Convert.ToDecimal(y1+approximateDistance),2));
								Point p = new Point(x1, y);
								return p;
							}
							else if(y1>y2)
							{
								double y = Convert.ToDouble(Math.Round(Convert.ToDecimal(y1-approximateDistance),2));
								Point p = new Point(x1, y);
								return p;
							}
							else //if(y1==y2)
							{
								return point1;
							}
						}
						else//y1==y2
						{
							if(x1<x2)
							{
								double x = Convert.ToDouble(Math.Round(Convert.ToDecimal(x1+approximateDistance),2));
								Point p = new Point(x, y1);
								return p;                          
							}
							else if(x1>x2)
							{
								double x = Convert.ToDouble(Math.Round(Convert.ToDecimal(x1-approximateDistance),2));
								Point p = new Point(x, y1);
								return p;                          
							}
							else
							{
								return point1;
							}               
						}
					}
					else if((x1-x2)*(y1-y2)>0)//when slope >0
					{
						//MessageBox.Show("when slope > zero");
						//MessageBox.Show("("+x1+","+y1+")  ("+x2+","+y2+")");
						if(x1<x2)
						{
							Point p = new Point ((x1+toCalculateX), (y1+toCalculateY));
							return p;                      
						}
						else
						{
							Point p = new Point ((x1-toCalculateX), (y1-toCalculateY));
							return p;
						}
					}
					else//when slope < 0
					{
						//MessageBox.Show("when slope < zero");
						//MessageBox.Show("("+x1+","+y1+")  ("+x2+","+y2+")");
						if(x1>x2)
						{
							Point p = new Point ((x1-toCalculateX), (y1+toCalculateY));
							return p;                      

						}
						else //x1<x2
						{
							//Console.WriteLine("y1 ="+y1);
							//Console.WriteLine("toCalculateY ="+toCalculateY);

							Point p = new Point ((x1+toCalculateX), (y1-toCalculateY));
							return p;                      

						}
					}
				}//if
				else
				{
					return new Point(-1,-1);
				}
			}//try
			catch(Exception e)
			{
				MessageBox.Show("Exception in getPointOnTheWay() : "+e.Message);
				Point p = new Point(-1, -1);
				return p;
			}
		
		}
		private bool isConnected(Point p1, Point p2)
		{
			if(getDistance(p1,p2)<=_PowerRange)
			{
				return true;
			}
			else
			{
				return false;   
			}
		}//is connected: bool

		private Point getPointFromNodeList(string p_node, Hashtable p_node_list)
		{
			IDictionaryEnumerator ide = p_node_list.GetEnumerator();
			Point point = new Point();
			while(ide.MoveNext())
			{
				if(ide.Key.ToString().Equals(p_node))
				{
					point = (Point)ide.Value;
					break;
				}
			}
			return point;
		}
		private void connect(ref Graphics g, Point p1, Point p2)
		{
			int x1 = Convert.ToInt32(p1.row);
			int y1 = Convert.ToInt32(p1.col);
			int x2 = Convert.ToInt32(p2.row);
			int y2 = Convert.ToInt32(p2.col);
			//MessageBox.Show("Connected Pair: ("+x1+","+y1+") ("+x2+" , "+y2+")");
			Pen pen = new Pen(Color.Gray);
			adjustPositions(ref x1, ref y1, ref x2, ref y2);
			//MessageBox.Show("After adjustPositions(): ("+x1+","+y1+") ("+x2+" , "+y2+")");
			g.DrawLine(pen,x1,y1,x2,y2);
		}

		private void showInsideVisited()
		{
			string inside ="";
			IEnumerator ie = visited.GetEnumerator();
			while(ie.MoveNext())
			{
				inside = inside+ie.Current.ToString()+" ";
			}
			//MessageBox.show("Inside Visited : "+inside);
		}

		private void GENUI_NT_Load(object sender, System.EventArgs e)
		{
			try
			{
				hashSequence = new Hashtable();
				xmlDoc.Load(new StreamReader(GEN_CONSTANTS.FILE_NAME_CONF));
				storeSequenceInHashtable();			
			}
			catch(Exception ex)
			{
                MessageBox.Show("Exception in GENUI_NT_Load(): "+ex.Message);
			}
		}


		public struct Sequence
		{
			public Point destination;
			public int speed;
			public int pause;

		}
	}//end of class
}
